from Acquisition import aq_base, aq_parent
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from OFS.History import Historical
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.PortalContent  import PortalContent
#from debug import log, log_exc
from Products.Archetypes.BaseContent import BaseContent, BaseContentMixin
from Products.Archetypes.public import BaseSchema

from Products.Archetypes.interfaces.metadata import IExtensibleMetadata

from Products.PloneArticle.ArticleAttachments import ArticleAttachments as Attachments
from Products.PloneArticle.ArticleImages import ArticleImages as Images

class BaseArchetypesArticle(BaseContent, Attachments, Images):
    """
    A not-so-basic CMF/Archetypes-based Article implementation.
    """

#need DublinCore, so this won't work
#     __implements__ = (BaseContentMixin.__implements__ +
#                       (IExtensibleMetadata,))
#     __implements__ = (BaseContent.__implements__ +
#                       (IExtensibleMetadata,))

    schema = BaseSchema

    def __init__(self, oid, **kwargs):
        BaseContent.__init__(self, oid, **kwargs)
        Attachments.__init__(self)
        Images.__init__(self)

InitializeClass(BaseArchetypesArticle)





#### HERE IS AN EXAMPLE CODE YOU CAN COPY/PASTE IN YOUR NEW PRODUCT:
#### The product is called MyArticle.

##from Products.Archetypes.public import Schema, BaseSchema
##from Products.Archetypes.BaseContent import BaseContent, BaseContentMixin
##from Products.Archetypes.public import TextField, StringField
##from Products.Archetypes.public import TextAreaWidget, RichWidget, SelectionWidget, EpozWidget, VisualWidget
##from Products.Archetypes.public import BaseContent, registerType
##from Products.Archetypes.interfaces.metadata import IExtensibleMetadata

##from Products.CMFCore import CMFCorePermissions

##from Products.PloneArticle.BaseArchetypesArticle import BaseArchetypesArticle

##from AccessControl import ClassSecurityInfo
##import string


##class MyArticle(BaseArchetypesArticle, ):
##    """An Archetype example type"""

##    # Since we have customized the default Metadata schema into ArticleInfos...
##    schema = BaseContentMixin.schema # + .... (add your own schemas)

##    actions = (
##    {
##    'id'           : 'view',
##    'name'         : 'View',
##    'action'       : 'string:${object_url}/MyArticle_view',
##    'permissions'   : (CMFCorePermissions.View, ),
##    'category'      : 'object',
##    },
##    {
##    'id'            : 'metadata',
##    'name'          : 'Properties',
##    'action'        : 'string:${object_url}/metadata_edit_form',
##    'permissions'   : (CMFCorePermissions.ModifyPortalContent, ),
##    'category'      : 'object',
##    },
##    {
##    'id'           : 'image',
##    'name'         : 'Images',
##    'action'       : 'string:${object_url}/PloneArticle_imageForm2',
##    'permissions'   : (CMFCorePermissions.ModifyPortalContent, ),
##    'category'      : 'object',
##    },
##    {
##    'id'           : 'attach',
##    'name'         : 'Attachments',
##    'action'       : 'string:${object_url}/PloneArticle_attachmentForm2',
##    'permissions'   : (CMFCorePermissions.ModifyPortalContent, ),
##    'category'      : 'object',
##    },
##    )

##    # Standard security settings
##    security = ClassSecurityInfo()


##    def __init__(self, oid, **kwargs):
##        BaseArchetypesArticle.__init__(self, oid, **kwargs)


##    #                                                                           #
##    #                    SPECIFIC CMF CATALOG SUPPORT                           #
##    #                                                                           #

##    security.declareProtected(CMFCorePermissions.View, 'SearchableText')
##    def SearchableText(self):
##        "Returns a concatanation of all searchable text"
##        ret = "%s %s %s %s" % (
##            self.Title(),                                                        # Essential metadata
##            self.Description(),
##            self.getText(),                                                      # Use the accessor for the 'text' field
##            string.join(map(lambda x: x.SearchableText(), self.listAttachments()), " ") +
##            string.join(map(lambda x: x.title_or_id(), self.listImages()), " ") 
##            )
##        return ret


##registerType(MyArticle)

