from config import PROJECTNAME
from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions
from Products.Archetypes.Marshall import RFC822Marshaller

"""
    Demonstration of an Article-ish type that can hold many
    subobjects, i.e. Links, Files.

    As a bonus, let's limit the allowable objects to those.

    Custom folderish content is a bit tricky in Plone -
    Plone has some internal properties (under portal_properties/site_properties)
    that defines which content types get folderish tabs.

    Some of this stuff is hardcoded, making it impossible to define your
    own customer folder_contents without making the new view system-wide.

    This content type has some extra installation code in Extenions/Install.py
"""

def modify_fti(fti):
    fti['allow_discussion'] = 'none'
    # hide unnecessary tabs (usability enhancement)
    for a in fti['actions']:
        if a['id'] in ('references',):
            a['visible'] = 0
    return fti
    


schema = BaseSchema

class WebPageFolder(BaseFolder):
    """
Folder which only holds WebPages, displays summaries with logos.
    """

    schema = schema
    meta_type = 'FolderLike'
    filter_content_types = 1
    allowed_content_types = ('WebPage',)

    content_icon = "group.gif"

    actions = ({
        'id': 'view',
        'name': 'View',
        'action': 'string:${object_url}/webpage_folder_view',
        'permissions': (CMFCorePermissions.View,)
        },)
    ##
    ## redefine all actions - we need category set to 'category'.
    ## We could probably also modify the fti (factory type information)
    ## using a module method 'modify_fti'
    ##
    ## Also note the extra folder code in Extentions/Install.py
#     actions = (
#                 { 'id': 'view',
#                   'name': 'View',
#                   'action': 'base_view',
#                   'permissions': (CMFCorePermissions.View,),
#                   'category':'folder',
#                   },
# 
#                 { 'id': 'edit',
#                   'name': 'Edit',
#                   'action': 'base_edit',
#                   'permissions': (CMFCorePermissions.ModifyPortalContent,),
#                   'category':'folder',
#                   },
# 
#                 { 'id': 'metadata',
#                   'name': 'Properties',
#                   'action': 'base_metadata',
#                   'permissions': (CMFCorePermissions.ModifyPortalContent,),
#                   'category':'folder',
#                   },
# 
#                 { 'id': 'references',
#                   'name': 'References',
#                   'action': 'reference_edit',
#                   'permissions': (CMFCorePermissions.ModifyPortalContent,),
#                   'category':'folder',
#                   },
#               )

    
registerType(WebPageFolder)
